#pragma once
#include "arch/Keyboard.h"
#include "fs/devices/DeviceRegistry.h"
#include <bits/termios.h>
#include <luna/Buffer.h>

class ConsoleDevice : public Device
{
  public:
    // Initializer for DeviceRegistry.
    static Result<void> create();

    Result<usize> read(u8*, usize, usize) const override;

    Result<usize> write(const u8*, usize, usize) override;

    bool will_block_if_read() const override
    {
        return false;
    }

    StringView device_path() const override
    {
        return "kmsg";
    }

    virtual ~ConsoleDevice() = default;
};
